<?php

namespace dgsoft\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for FareRuleResponseInfoTypeAdvisoryInfo StructType
 * @package Dg
 * @subpackage Structs
 */
class DgFareRuleResponseInfoTypeAdvisoryInfo extends DgFreeTextType
{
    /**
     * The _
     * @var \dgsoft\StructType\DgFreeTextType
     */
    public $_;
    /**
     * The AdvisoryCode
     * @var string
     */
    public $AdvisoryCode;
    /**
     * Constructor method for FareRuleResponseInfoTypeAdvisoryInfo
     * @uses DgFareRuleResponseInfoTypeAdvisoryInfo::set_()
     * @uses DgFareRuleResponseInfoTypeAdvisoryInfo::setAdvisoryCode()
     * @param \dgsoft\StructType\DgFreeTextType $_
     * @param string $advisoryCode
     */
    public function __construct(\dgsoft\StructType\DgFreeTextType $_ = null, $advisoryCode = null)
    {
        $this
            ->set_($_)
            ->setAdvisoryCode($advisoryCode);
    }
    /**
     * Get _ value
     * @return \dgsoft\StructType\DgFreeTextType|null
     */
    public function get_()
    {
        return $this->_;
    }
    /**
     * Set _ value
     * @param \dgsoft\StructType\DgFreeTextType $_
     * @return \dgsoft\StructType\DgFareRuleResponseInfoTypeAdvisoryInfo
     */
    public function set_(\dgsoft\StructType\DgFreeTextType $_ = null)
    {
        $this->_ = $_;
        return $this;
    }
    /**
     * Get AdvisoryCode value
     * @return string|null
     */
    public function getAdvisoryCode()
    {
        return $this->AdvisoryCode;
    }
    /**
     * Set AdvisoryCode value
     * @param string $advisoryCode
     * @return \dgsoft\StructType\DgFareRuleResponseInfoTypeAdvisoryInfo
     */
    public function setAdvisoryCode($advisoryCode = null)
    {
        // validation for constraint: string
        if (!is_null($advisoryCode) && !is_string($advisoryCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($advisoryCode)), __LINE__);
        }
        $this->AdvisoryCode = $advisoryCode;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \dgsoft\StructType\DgFareRuleResponseInfoTypeAdvisoryInfo
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
